# Adding issue operation links to the email

<mark style="color:green;">SINCE VERSION 6.1</mark>

Jira Email This Issue allows you to include issue operation links in the email body. All you need to do is to select **Operation Links** in the Field Picker dropdown in the email template editor.

![](/files/mHVAcZUFBpnT1sSldGMP)

In the HTML editor, you can add a placeholder in your email template for the operation links:

![](/files/1mW00kb8u0zwwNjkbLWc)

### Rendering links <a href="#addissueoperationlinkstotheemail-howlinksarerendered" id="addissueoperationlinkstotheemail-howlinksarerendered"></a>

When you include the above mentioned template fragments, Email This Issue will use the following  code to render the operation links. If you want to customize how operation links are rendered, change layout or styles, include the following codeblock directly in your template and tailor it to your needs.

**Example template codeblock rendering links in HTML emails**

```
#set ($transitions = $!jetiFieldRenderer.getWorkflowActions($!issue))
#if ($!transitions && $!transitions.size() > 0)
#foreach($transition in $!transitions)
<a style="border-left:1px solid #ccc; padding:4px 10px; float:left;" href="$baseurl/secure/WorkflowUIDispatcher.jspa?id=$issue.id&action=$!transition.id">$!transition.name</a>
#end
#end
```

**Example template codeblock rendering links in Text emails**

```
#set ($transitions = $!jetiFieldRenderer.getWorkflowActions($!issue))
#if ($!transitions && $!transitions.size() > 0)
#foreach($transition in $!transitions)
$stringUtils.leftPad($!transition.name, $padSize): $baseurl/secure/WorkflowUIDispatcher.jspa?id=$issue.id&action=$!transition.id
#end
#end
```

{% hint style="warning" %}
**Important**: Form token errors will occur!&#x20;

Jira has protection against various web security vulnerability, like CSS, XSRF etc. Jira uses form tokens in each links it exposes. These tokens are uniquely generated for each request/response. Read more details in the Jira [documentation](https://developer.atlassian.com/jiradev/jira-architecture/authentication/form-token-handling).

We cannot provide a workaround for this token checking, this means when you open an operation link from email, you'll see an error screen even if you have a running session in your browser.

When the following error message is shown, simply click **Retry Operation** to execute the operation. You may still need to log in. After all these the operation will be called and you can proceed with the transition.
{% endhint %}

![](/files/A1xtUIZaCWTpl9ai3xBj)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.meta-inf.hu/email-this-issue/email-this-issue-for-jira-server-data-center/documentation/outgoing-emails/email-templates/adding-issue-operation-links-to-the-email.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
